package com.bonait.bnframework.modules.home.fragment.from;

import static com.bonait.bnframework.MainApplication.getContext;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View;

import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.res.StatusMode;
import com.bonait.bnframework.common.modbus.ModbusMaster;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.devstatus_adapter;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;

public class RealTimeActivity extends BaseActivity {

    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;
    @BindView(R.id.recycler_view)
    RecyclerView recycler_view;
    private Context context;
    Activity activity=null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_realtime);
        ButterKnife.bind(this);
        context=getContext();
        activity=this;
        initTopBar();
        initFragment();
    }

    private void initTopBar() {
        mTopBar.setTitle("实时监控管理");
        mTopBar.addLeftImageButton(R.mipmap.fanhui,R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
    }
    public devstatus_adapter adapter=null;
    /**
     * viewPager里添加fragment
     */
    private void initFragment() {

        Initdata();
        MyLayoutManager layout = new MyLayoutManager();
        layout.setAutoMeasureEnabled(true);
        recycler_view.setLayoutManager(layout);
        adapter = new devstatus_adapter(getContext(),this);
        recycler_view.setAdapter(adapter);
    }

    /**
     * 初始化数据加载
     */
    public void Initdata()
    {
        try{
            DataBus.getInstance().statusModes=new ArrayList<>();
            switch (ConfigName.getInstance().versionSelectionEnum){
                case "味魔方":
                    DataBus.getInstance().statusModes.add(new StatusMode("通道一开关",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道二开关",R.mipmap.csf1,R.mipmap.csf2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道三开关",R.mipmap.csf1,R.mipmap.csf2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道四开关",R.mipmap.rdl1,R.mipmap.rdl2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("通道五开关",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道六开关",R.mipmap.csf1,R.mipmap.csf2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道七开关",R.mipmap.csf1,R.mipmap.csf2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道八开关",R.mipmap.rdl1,R.mipmap.rdl2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("通道九开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道十开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道十一开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道十二开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道十三开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("通道十四开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    break;

                case "调味吧台":
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓一正转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓二正转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓三正转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓四正转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓五正转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓六正转",R.mipmap.rdl1,R.mipmap.rdl2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("加热仓一正转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("加热仓二正转",R.mipmap.rdl1,R.mipmap.rdl2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓一反转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓二反转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓三反转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓四反转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓五反转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("外置仓六反转",R.mipmap.rdl1,R.mipmap.rdl2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("加热仓一反转",R.mipmap.rdl1,R.mipmap.rdl2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("加热仓二反转",R.mipmap.rdl1,R.mipmap.rdl2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("粉料仓一开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("粉料仓二开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("粉料仓三开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("粉料仓四开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("粉料仓五开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("粉料仓六开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));

                    DataBus.getInstance().statusModes.add(new StatusMode("普通液体仓一开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    DataBus.getInstance().statusModes.add(new StatusMode("普通液体仓二开关",R.mipmap.djcgq1,R.mipmap.djcgq2,false));
                    break;

                case "奶茶机":
                    break;
            }

            Run();

        }catch(Exception e){

        }
    }

    /**
     * 设置状态显示
     * @param i
     * @param bool
     */
    public void SetStatus(int i,boolean bool)
    {
        if(DataBus.getInstance().statusModes.size()>=i)
        {
            StatusMode mode= DataBus.getInstance().statusModes.get(i);
            mode.Status=bool;
            DataBus.getInstance().statusModes.set(i,mode);
        }
    }

    /**
     * 实时显示线程
     */
    public void Run() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                //while (ConfigName.getInstance().SerialIsConnect) {
                while (ModbusMaster.get().IsConnected) {
                    try {
                        runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                try {
                                    String sysName=ConfigName.getInstance().versionSelectionEnum;
                                    switch (sysName){
                                        case "味魔方":
                                            for (int i=0;i<14;i++){
                                                SetStatus(i,ExecuteTheRecipe.getConcurrentHash(i));
                                            }
                                            break;
                                        case "调味吧台":
                                            for (int i=0;i<24;i++){
                                                SetStatus(i,ExecuteTheRecipe.getConcurrentHash(i));
                                            }
                                            break;
                                        case "奶茶机":

                                            break;
                                        default:
                                            break;
                                    }
                                    adapter.refresh();
                                } catch (Exception e) {
                                }
                            }
                        });
                        Thread.sleep(500);
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                }
            }
        }).start();
    }
    //-------------------------配置viewPager与fragment关联----------------------------//

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }
}