package com.bonait.bnframework.modules.home.fragment.from;

import static com.bonait.bnframework.MainApplication.getContext;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_SYSTEMSET;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class SystemParameterActivity extends BaseActivity {

    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;
    private Context context;

    @BindView(R.id.edittext1)
    EditText edittext1;
    @BindView(R.id.edittext2)
    EditText edittext2;
    @BindView(R.id.edittext3)
    EditText edittext3;
    @BindView(R.id.edittext4)
    EditText edittext4;

    @BindView(R.id.serialBaudRate)
    Spinner serialBaudRate;

    @BindView(R.id.serialDataBits)
    Spinner serialDataBits;
    @BindView(R.id.serialParity)
    Spinner serialParity;
    @BindView(R.id.serialStopBits)
    Spinner serialStopBits;

    @BindView(R.id.environment)
    Spinner environment;

    @BindView(R.id.versionselection)
    Spinner versionselection;



    ArrayList<EditText> editTextLists = new ArrayList<>();
    Map<String, Integer> material_map = new LinkedHashMap<>();
    Map<String, Integer> material_map_vis = new LinkedHashMap<>();

    Map<String, Integer> baudRate_map = new LinkedHashMap<>();
    Map<String, Integer> dataBits_map = new LinkedHashMap<>();
    Map<String, Integer> parity_map = new LinkedHashMap<>();
    Map<String, Integer> stop_Bits = new LinkedHashMap<>();

    /**
     * 系统设置参数
     */
    ArrayList<BPA_SYSTEMSET> bpa_systemsets = new ArrayList<>();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_systemparameter);
        ButterKnife.bind(this);
        context=getContext();
        initTopBar();
        initFragment();
        try {
            initData();
            initSelect();
        }catch (Exception e){

        }

    }

    private void initTopBar() {
        mTopBar.setTitle("系统参数");
        mTopBar.addLeftImageButton(R.mipmap.fanhui,R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();              }
        });
    }
    /**
     * viewPager里添加fragment
     */
    private void initFragment() {

    }

    private void initData() {
        editTextLists.add(edittext1);
        editTextLists.add(edittext2);
        editTextLists.add(edittext3);
        editTextLists.add(edittext4);

        material_map.put("开发环境", 0);
        material_map.put("测试环境", 1);
        material_map.put("正式环境", 2);

        baudRate_map.put("9600",0);
        baudRate_map.put("19200",1);
        baudRate_map.put("115200",2);

        dataBits_map.put("7",0);
        dataBits_map.put("8",1);

        parity_map.put("0",0);
        parity_map.put("1",1);
        parity_map.put("2",2);

        stop_Bits.put("1",0);
        stop_Bits.put("2",1);

        for (int i = 0; i < ConfigName.getInstance().versionSelectionValues.length; i++) {
            material_map_vis.put(ConfigName.getInstance().versionSelectionValues[i], i);
        }


        ArrayAdapter<String> adapter = new ArrayAdapter<>(context, R.layout.spinner_text_item, new ArrayList<>(material_map.keySet()));
        adapter.setDropDownViewResource(R.layout.spinner_dropdown_item);
        environment.setAdapter(adapter);

        ArrayAdapter<String> adapter1 = new ArrayAdapter<>(context, R.layout.spinner_text_item, new ArrayList<>(material_map_vis.keySet()));
        adapter1.setDropDownViewResource(R.layout.spinner_dropdown_item);
        versionselection.setAdapter(adapter1);

        ArrayAdapter<String> adapter2 = new ArrayAdapter<>(context, R.layout.spinner_text_item, new ArrayList<>(baudRate_map.keySet()));
        adapter2.setDropDownViewResource(R.layout.spinner_dropdown_item);
        serialBaudRate.setAdapter(adapter2);

        ArrayAdapter<String> adapter3 = new ArrayAdapter<>(context, R.layout.spinner_text_item, new ArrayList<>(dataBits_map.keySet()));
        adapter3.setDropDownViewResource(R.layout.spinner_dropdown_item);
        serialDataBits.setAdapter(adapter3);

        ArrayAdapter<String> adapter4 = new ArrayAdapter<>(context, R.layout.spinner_text_item, new ArrayList<>(parity_map.keySet()));
        adapter4.setDropDownViewResource(R.layout.spinner_dropdown_item);
        serialParity.setAdapter(adapter4);

        ArrayAdapter<String> adapter5 = new ArrayAdapter<>(context, R.layout.spinner_text_item, new ArrayList<>(stop_Bits.keySet()));
        adapter5.setDropDownViewResource(R.layout.spinner_dropdown_item);
        serialStopBits.setAdapter(adapter5);



        bpa_systemsets = QueryDB.GetSystemsetALL();
        for (BPA_SYSTEMSET item : bpa_systemsets) {
            switch (item.type) {
                case -100:
                    ConfigName.getInstance().versionSelectionEnum = item.value;
                    versionselection.setSelection(material_map_vis.get(item.value));
                    break;
                case -99:
                    ConfigName.getInstance().Environment = item.value;
                    environment.setSelection(material_map.get(item.value));
                    break;
                case 1:
                    ConfigName.getInstance().Address = item.value;
                    edittext1.setText(item.value);
                    break;
                case 2:
                    ConfigName.getInstance().Post = Integer.parseInt(item.value);
                    edittext2.setText(item.value);
                    break;
                case 3:
                    ConfigName.getInstance().ClientAutoKey = item.value;
                    edittext3.setText(item.value);
                    break;
                case 4:
                    ConfigName.getInstance().DeviceAutoKey = item.value;
                    edittext4.setText(item.value);
                    break;
//                case 20:
//                    ConfigName.getInstance().SerialBaudRate = Integer.parseInt(item.value);
//                    serialBaudRate.setSelection(baudRate_map.get(item.value));
//                    break;
//                case 21:
//                    ConfigName.getInstance().SerialDataBits = Integer.parseInt(item.value);
//                    serialDataBits.setSelection(dataBits_map.get(item.value));
//                    break;
//                case 22:
//                    ConfigName.getInstance().SerialParity = Integer.parseInt(item.value);
//                    serialParity.setSelection(parity_map.get(item.value));
//                    break;
//                case 23:
//                    ConfigName.getInstance().SerialStopBits = Integer.parseInt(item.value);
//                    serialStopBits.setSelection(stop_Bits.get(item.value));
//                    break;
            }
        }
    }

    /**
     * 初始化选中
     */
    public void initSelect() {


    }

    @OnClick({R.id.StartButton})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.StartButton://保存按钮
                ConfigName.getInstance().Address = edittext1.getText().toString();
                ConfigName.getInstance().Post = Integer.parseInt(edittext2.getText().toString());
                ConfigName.getInstance().ClientAutoKey = edittext3.getText().toString();
                ConfigName.getInstance().DeviceAutoKey = edittext4.getText().toString();

                ConfigName.getInstance().Environment = environment.getSelectedItem().toString();

                boolean isgb = false;
                if (!ConfigName.getInstance().versionSelectionEnum.equals(versionselection.getSelectedItem().toString())) {
                    ConfigName.getInstance().versionSelectionEnum = versionselection.getSelectedItem().toString();
                    isgb = true;
                }

                for (BPA_SYSTEMSET item : bpa_systemsets) {
                    QueryDB.DeleteSystemset(item.id);
                }

                for (int i = 0; i < editTextLists.size(); i++) {
                    BPA_SYSTEMSET set = new BPA_SYSTEMSET();
                    set.type = i + 1;
                    set.value = editTextLists.get(i).getText().toString();
                    set.deviceID = ConfigName.getInstance().DeviceId;
                    set.userID = ConfigName.getInstance().user.userID;
                    QueryDB.AddSystemset(set);
                }
                BPA_SYSTEMSET set = new BPA_SYSTEMSET();
                set.type = -99;
                set.value = environment.getSelectedItem().toString();
                set.deviceID = ConfigName.getInstance().DeviceId;
                set.userID = ConfigName.getInstance().user.userID;
                QueryDB.AddSystemset(set);

                BPA_SYSTEMSET set_vis = new BPA_SYSTEMSET();
                set_vis.type = -100;
                set_vis.value = versionselection.getSelectedItem().toString();
                set_vis.deviceID = ConfigName.getInstance().DeviceId;
                set_vis.userID = ConfigName.getInstance().user.userID;
                QueryDB.AddSystemset(set_vis);

                //saveSerialParam();

                if (isgb) {
                    ConfigData.getInstance().RevertPLCProcess();
                }
                ToastUtils.info("保存成功");
                break;

        }
    }
    //-------------------------配置viewPager与fragment关联----------------------------//

    /**保存串口设置参数*/
//    private void saveSerialParam(){
//        BPA_SYSTEMSET set_baudrate = new BPA_SYSTEMSET();
//        set_baudrate.type = 20;
//        set_baudrate.value =serialBaudRate.getSelectedItem().toString();
//        set_baudrate.deviceID = ConfigName.getInstance().DeviceId;
//        set_baudrate.userID = ConfigName.getInstance().user.userID;
//        QueryDB.AddSystemset(set_baudrate);
//
//        BPA_SYSTEMSET set_dataBits = new BPA_SYSTEMSET();
//        set_dataBits.type = 21;
//        set_dataBits.value = serialDataBits.getSelectedItem().toString();
//        set_dataBits.deviceID = ConfigName.getInstance().DeviceId;
//        set_dataBits.userID = ConfigName.getInstance().user.userID;
//        QueryDB.AddSystemset(set_dataBits);
//
//        BPA_SYSTEMSET set_parity = new BPA_SYSTEMSET();
//        set_parity.type = 22;
//        set_parity.value =serialParity.getSelectedItem().toString();
//        set_parity.deviceID = ConfigName.getInstance().DeviceId;
//        set_parity.userID = ConfigName.getInstance().user.userID;
//        QueryDB.AddSystemset(set_parity);
//
//        BPA_SYSTEMSET set_stopBits = new BPA_SYSTEMSET();
//        set_stopBits.type = 23;
//        set_stopBits.value = serialStopBits.getSelectedItem().toString();
//        set_stopBits.deviceID = ConfigName.getInstance().DeviceId;
//        set_stopBits.userID = ConfigName.getInstance().user.userID;
//        QueryDB.AddSystemset(set_stopBits);
//    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }
}