package com.bonait.bnframework.modules.home.fragment.mode;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.os.SystemClock;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.fragment.app.FragmentManager;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.business.deviceControl.PLCControl;
import com.bonait.bnframework.business.deviceControl.ScaleDevice;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_SILOS;
import com.bonait.bnframework.common.db.res.UserLogEnum;
import com.bonait.bnframework.common.db.res.lcMode;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;
import com.suke.widget.SwitchButton;

import org.apache.commons.math3.fitting.PolynomialCurveFitter;
import org.apache.commons.math3.fitting.WeightedObservedPoints;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class silos_jiaoyan extends LinearLayout {
    //region qita
    @BindView(R.id.close_from)
    Button close_from;
    @BindView(R.id.title_bc)
    TextView title_bc;
    /**
     * 当前料仓
     */
    public lcMode lcMode = null;
    /**
     * 窗体
     */
    public FragmentManager fragmentManager;
    /**
     * 点击事件
     */
    public MyClickListener mListener=null;
    private View root;
    //endregion

    //region 界面布局
    @BindView(R.id.wuliaojiaozhun)
    LinearLayout wuliaojiaozhun;
    @BindView(R.id.manguanjiaozhun)
    LinearLayout manguanjiaozhun;
    @BindView(R.id.jiaoliaojiaozhun)
    LinearLayout jiaoliaojiaozhun;
    @BindView(R.id.buchangjiaozhun)
    LinearLayout buchangjiaozhun;
    //endregion

    //region 称相关
    @BindView(R.id.dianzicheng1)
    TextView dianzicheng1;
    @BindView(R.id.dianzicheng2)
    TextView dianzicheng2;
    @BindView(R.id.dianzicheng3)
    TextView dianzicheng3;

    @BindView(R.id.chuliaokeshu1)
    EditText chuliaokeshu1;
    @BindView(R.id.chuliaokeshu2)
    EditText chuliaokeshu2;
    @BindView(R.id.chuliaokeshu3)
    EditText chuliaokeshu3;
    //endregion

    //region 满管
    @BindView(R.id.runtime)
    Chronometer runtime;

    @BindView(R.id.exit_mgjz)
    EditText exit_mgjz;

    final int[] time = {0};

    final int[] zl = {0};

    public boolean isStartMg=false;
    //endregion

    //region 物料校准变量
    /**物料校准--校准时间*/
    @BindView(R.id.wljz1)
    EditText wljz1;

    /**物料校准--反转时间*/
    @BindView(R.id.wljz2)
    EditText wljz2;

    /**物料校准--校准重量*/
    @BindView(R.id.wljz3)
    EditText wljz3;

    @BindView(R.id.text_wljz)
    TextView text_wljz2;
    //endregion

    //region 通道补偿
    @BindView(R.id.control_switch)
    SwitchButton control_switch;

    @BindView(R.id.bcjz_gxs)
    EditText bcjz_gxs;

    @BindView(R.id.bcjz_dxs)
    EditText bcjz_dxs;

    @BindView(R.id.bcjz_clsj)
    EditText bcjz_clsj;
    //endregion

    //region 酱料校准的控件
    /**酱料校准下限*/
    @BindView(R.id.txt_jljz_lowLimit)
    EditText txt_jljz_lowLimit;


    /**酱料校准上限*/
    @BindView(R.id.txt_jljz_highLimit)
    EditText txt_jljz_highLimit;


    /**酱料校准频率*/
    @BindView(R.id.txt_jljz_adjFreq)
    EditText txt_jljz_adjFreq;

//    /**酱料校准反转时间输入框*/
//    @BindView(R.id.text_jljz_ftime1)
//    EditText text_jljz_ftime1;

    /**酱料校准反转时间输入框*/
    @BindView(R.id.text_jljz_ftime)
    EditText text_jljz_ftime;
    /**开始酱料校准*/
    @BindView(R.id.btn_jljz_startAdj)
    Button btn_jljz_startAdj;

    /**保存酱料反转时间*/
    @BindView(R.id.btn_jljz_saveFTime)
    Button btn_jljz_saveFTime;
    //endregion

    public silos_jiaoyan(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        root= LayoutInflater.from(context).inflate(R.layout.silos_jiaoyan_item, this);
        ButterKnife.bind(this, root);
        //初始化界面控件的事件
        initEvent();
    }


    @BindView(R.id.text_wlkz)
    TextView text_wlkz;
    @BindView(R.id.text_mgkz)
    TextView text_mgkz;

    @BindView(R.id.text_mgkz1)
    TextView text_mgkz1;
    @BindView(R.id.text_jlkz)
    TextView text_jlkz;
    @BindView(R.id.text_bckz)
    TextView text_bckz;

    @BindView(R.id.text_jlkz1)
    TextView text_jlkz1;
    @BindView(R.id.text_bckz1)
    TextView text_bckz1;
    /**
     * 初始化数据
     */
    private void initData()
    {
        title_bc.setText(lcMode.num+" "+lcMode.materialName);
        if(lcMode.name.equals("外置仓"))
        {
            text_wlkz.setVisibility(View.GONE);
            text_mgkz1.setVisibility(View.GONE);

            text_jlkz.setVisibility(View.VISIBLE);
            text_bckz.setVisibility(View.GONE);
            text_jlkz1.setVisibility(View.VISIBLE);
            text_bckz1.setVisibility(View.GONE);

        }else
        {
            text_wlkz.setVisibility(View.VISIBLE);
            text_mgkz1.setVisibility(View.VISIBLE);

            text_jlkz.setVisibility(View.GONE);
            text_bckz.setVisibility(View.GONE);
            text_jlkz1.setVisibility(View.GONE);
            text_bckz1.setVisibility(View.GONE);
        }
    }

    private void initEvent()
    {
        //关闭窗体
        close_from.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            ExecuteTheRecipe.WritePLC("通道" + lcMode.num + "校准开关", false, null);
                            ExecuteTheRecipe.WritePLC("手自切换", true, null);
                        } catch (Exception e) {

                        }
                    }
                }).start();
                if (mListener != null) {
                    mListener.clickListenerNew(v,0,null);
                }
            }
        });

        text_wlkz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                InitView("物料校准");
            }
        });
        text_mgkz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                InitView("满管校准");
            }
        });
        text_jlkz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                InitView("酱料校准");
            }
        });
        text_bckz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                InitView("补偿校准");
            }
        });

        control_switch.setOnCheckedChangeListener(new SwitchButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(SwitchButton view, boolean isChecked) {
                //设置
                boolean isopen = control_switch.isChecked();
                if (ConfigName.getInstance().PlcIsConnect) {
                    lcMode.isOpenbcsf=isopen?1:0;
                    ExecuteTheRecipe.WritePLC("通道" + lcMode.num + "补偿开关", isopen, null);
                    QueryDB.UpdateSilosisOpenbcsf(lcMode.id, isopen);
                    ToastUtils.info(lcMode.name.toString() + (isopen ? "打开" : "关闭") + "成功!");
                } else {
                    ToastUtils.warning(lcMode.name.toString() + (isopen ? "打开" : "关闭") + "失败!PLC未连接！！");
                }
            }
        });
    }

    Activity activity =null;
    /**
     * 设置数据
     * @param
     */
    public void SetData(lcMode _lcMode,Activity ac)
    {
        activity=ac;
        this.lcMode=_lcMode;
        initData();
        //InitView("物料校准");
        if (lcMode.name.equals("外置仓")){
            InitView("酱料校准");
        }else{
            InitView("物料校准");
        }

        Run();
    }


    //region 初始化设置数据
    public String TypeName="物料校准";
    /**
     * 初始化界面
     */
    public void InitView(String _TypeName) {
        TypeName=_TypeName;
        switch (TypeName) {
            case "满管校准":
                wuliaojiaozhun.setVisibility(View.GONE);
                manguanjiaozhun.setVisibility(View.VISIBLE);
                jiaoliaojiaozhun.setVisibility(View.GONE);
                buchangjiaozhun.setVisibility(View.GONE);

                text_wlkz.setTextColor(Color.BLACK);
                text_mgkz.setTextColor(Color.parseColor("#7dcce1"));
                text_jlkz.setTextColor(Color.BLACK);
                text_bckz.setTextColor(Color.BLACK);
                break;
            case "酱料校准":
                wuliaojiaozhun.setVisibility(View.GONE);
                manguanjiaozhun.setVisibility(View.GONE);
                jiaoliaojiaozhun.setVisibility(View.VISIBLE);
                buchangjiaozhun.setVisibility(View.GONE);

                text_wlkz.setTextColor(Color.BLACK);
                text_mgkz.setTextColor(Color.BLACK);
                text_jlkz.setTextColor(Color.parseColor("#7dcce1"));
                text_bckz.setTextColor(Color.BLACK);
                break;
            case "补偿校准":
                wuliaojiaozhun.setVisibility(View.GONE);
                manguanjiaozhun.setVisibility(View.GONE);
                jiaoliaojiaozhun.setVisibility(View.GONE);
                buchangjiaozhun.setVisibility(View.VISIBLE);

                text_wlkz.setTextColor(Color.BLACK);
                text_mgkz.setTextColor(Color.BLACK);
                text_jlkz.setTextColor(Color.BLACK);
                text_bckz.setTextColor(Color.parseColor("#7dcce1"));
                break;
            default:
                wuliaojiaozhun.setVisibility(View.VISIBLE);
                manguanjiaozhun.setVisibility(View.GONE);
                jiaoliaojiaozhun.setVisibility(View.GONE);
                buchangjiaozhun.setVisibility(View.GONE);

                text_wlkz.setTextColor(Color.parseColor("#7dcce1"));
                text_mgkz.setTextColor(Color.BLACK);
                text_jlkz.setTextColor(Color.BLACK);
                text_bckz.setTextColor(Color.BLACK);
                break;
        }

        /**
         * 计时器超时
         */
        runtime.setOnChronometerTickListener(new Chronometer.OnChronometerTickListener() {
            @Override
            public void onChronometerTick(Chronometer chronometer) {
                //如果计时到现在超过了一小时秒 20s
                if (SystemClock.elapsedRealtime() - runtime.getBase() > 20 * 1000) {
                    mHandler.sendEmptyMessage(1);
                }
            }
        });
    }
    //endregion

    //region 外部消息通知

    /**
     * 通知事件
     */
    public void Run() {
        //重量通知
        ExecuteTheRecipe.WeighComplete = new IRun() {
            @Override
            public void Run() {
                mHandler.sendEmptyMessage(0);
                if ((ExecuteTheRecipe.OutletWeigh >= (zl[0] + 2)) && isStartMg)//当前重量大于2g
                {
                    isStartMg=false;
                    mHandler.sendEmptyMessage(1);
                }
            }
        };
        //通道校准完成
        ExecuteTheRecipe.OnChargeMixtureComNotPar = new IRun() {
            @Override
            public void Run() {
                final int kkk = lcMode.num;
                try {
                    if(activity!=null)
                    {
                        activity.runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                try {
                                    new Handler().postDelayed(new Runnable() {
                                        @Override
                                        public void run() {
                                            // 在2秒后执行按钮操作
                                            int zhongliangxianshi = ExecuteTheRecipe.OutletWeigh;
                                            ExecuteTheRecipe.WritePLC("校准值" + kkk, (short) zhongliangxianshi, null);
                                            String s = String.valueOf(zhongliangxianshi);
                                            String zll = String.format("%.1f", (Double.parseDouble(s) / 10));
                                            wljz3.setText(zll + "");
                                            lcMode.jValue = zll;
                                            QueryDB.UpdateJYZ(lcMode.id, zll);
                                            ToastUtils.warning("通道校准完成！");
                                        }
                                    }, 2000);
                                } catch (Exception e) {
                                    ToastUtils.error("重量解析显示异常！" + e.getMessage());
                                }
                            }
                        });
                    }
                } catch (Exception ex) {
                    Log.d("dsds", "Run: " + ex.getMessage());
                }
            }
        };

        new Thread(new Runnable() {
            @Override
            public void run() {
                ExecuteTheRecipe.WritePLC("通道" + lcMode.num + "校准开关", true, null);
                if(activity!=null)
                {
                    activity.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            exit_mgjz.setText(lcMode.bValue + "");
                            //填充校准时间
                            String time = lcMode.jTime == null ? "0.0" : lcMode.jTime;
                            String ftime = lcMode.fTime == null ? "0.0" : lcMode.fTime;
                            String jvalue = lcMode.jValue == null ? "0.0" : lcMode.jValue;
                            wljz1.setText(time);
                            wljz2.setText(ftime);
                            wljz3.setText(jvalue);
                            text_jljz_ftime.setText(ftime);

                            String minWeight=lcMode.minweight==null?"0.0":lcMode.minweight;
                            String maxWeight=lcMode.maxweight==null?"0.0":lcMode.maxweight;
                            String jFrequency=lcMode.jfrequency==null?"0.0":lcMode.jfrequency;
                            txt_jljz_lowLimit.setText(minWeight);
                            txt_jljz_highLimit.setText(maxWeight);
                            txt_jljz_adjFreq.setText(jFrequency);


                            String Gxs = lcMode.Gxs == null ? "0.0" : lcMode.Gxs;
                            String Lxs = lcMode.Lxs == null ? "0.0" : lcMode.Lxs;
                            String tdclsj = lcMode.tdclsj == null ? "0.0" : lcMode.tdclsj;

                            control_switch.setChecked(lcMode.isOpenbcsf == 1);
                            bcjz_gxs.setText(Gxs);
                            bcjz_dxs.setText(Lxs);
                            bcjz_clsj.setText(tdclsj);
                        }
                    });
                }
            }
        }).start();
    }
    //endregion

    //region 刷新界面
    /**
     * 界面刷新
     */
    private Handler mHandler = new Handler() {
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 0:
                    dianzicheng1.setText(String.valueOf((int) ExecuteTheRecipe.OutletWeigh / 10.0) + " g");
                    dianzicheng2.setText(String.valueOf((int) ExecuteTheRecipe.OutletWeigh / 10.0) + " g");
                    dianzicheng3.setText(String.valueOf((int) ExecuteTheRecipe.OutletWeigh / 10.0) + " g");
                    break;
                case 1:
                    time[0] = StopTime();
                    lcMode.bValue = time[0];
                    exit_mgjz.setText(time[0] + "");
                    QueryDB.UpdateMGTime(lcMode.id, time[0]);
                    break;
                case 2:

                    break;
            }
        }
    };
    //endregion

    //region 点击事件
    @OnClick({
            R.id.qingling1, R.id.qingling2, R.id.qingling3,
            R.id.chuliao1, R.id.chuliao2, R.id.chuliao3,
            R.id.click_mgjz, R.id.click_mgjz_save,
            R.id.click_wljz, R.id.click_wljz_save,
             R.id.click_bcjz_save,R.id.btn_jljz_startAdj,R.id.btn_jljz_saveFTime
    })
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.qingling1:
            case R.id.qingling2:
            case R.id.qingling3:
                dzcql();
                break;
            case R.id.chuliao1:
            case R.id.chuliao2:
            case R.id.chuliao3:
                mncl();
                break;
            case R.id.click_mgjz://满管校准
                zl[0] = ExecuteTheRecipe.OutletWeigh;
                StartTime();
                break;
            case R.id.click_mgjz_save://满管校准 保存参数
                String value1 = exit_mgjz.getText().toString();
                int val1 = 0;
                try {
                    val1 = (value1 == null || value1.isEmpty()) ? 0 : Integer.parseInt(value1);
                    lcMode.bValue = val1;
                    QueryDB.UpdateMGTime(lcMode.id, val1);
                    ToastUtils.info("校准时间保存成功！");
                } catch (Exception e) {

                }
                break;
            case R.id.click_wljz://物料校准
                WLJZ();
                break;
            case R.id.click_wljz_save://物料校准 保存参数
                SaveWLJZ();
                break;
            case R.id.click_bcjz_save://补偿校准 保存参数
                SaveBCJZ();
                break;
            case R.id.btn_jljz_startAdj:
                JLJZ();
                break;
            case R.id.btn_jljz_saveFTime:
                saveJLFTime();
                break;
        }
    }
    //endregion

    //region 电子秤清零

    /**
     * 电子秤清零
     */
    public void dzcql() {
        //ExecuteTheRecipe.WritePLC("重量清零", true, new IWriteCallBack() {
        ScaleDevice.get().tare(new IWriteCallBack() {
        @Override
            public void onSuccess() {
                ToastUtils.info("清零成功！");
            }

            @Override
            public void onFailure(String ErrorMsg) {
                ToastUtils.error("清零失败！");
            }
        });
    }
    //endregion

    //region 模拟出料

    /**
     * 模拟出料
     */
    public void mncl() {
        String zltext = chuliaokeshu1.getText().toString();
        if (TypeName.equals("物料校准")) {
            zltext = chuliaokeshu1.getText().toString();
        } else if (TypeName.equals("酱料校准")) {
            zltext = chuliaokeshu2.getText().toString();
        } else if (TypeName.equals("补偿校准")) {
            zltext = chuliaokeshu3.getText().toString();
        }

        if (zltext.equals("")) {
            ToastUtils.warning("出料重量不能为空！");
            return;
        }
        double zl = 0;//需求重量。
        try {
            zl = Double.parseDouble(zltext);
        } catch (Exception e) {
            ToastUtils.warning("出料重量获取异常！" + e.getMessage());
            return;
        }
        if (zl <= 0) {
            ToastUtils.warning("出料重量至少大于0g！");
            return;
        }

//        if (ConfigName.getInstance().versionSelectionEnum.equals("奶茶机"))
//        {
//            if (!ExecuteTheRecipe.IsCup) {
//                ToastUtils.warning("出料口没有检测到器皿！");
//                return;
//            }
//        }


        //short kkk = (short) ((int) (zl * 10));

        final int[] delayTime=new int[]{0};
        final int ftime=(int)(Double.parseDouble(lcMode.fTime)*1000);
        if (TypeName.equals("酱料校准")){
            delayTime[0]=(int)(ExecuteTheRecipe.getDelayTimeByLCID(lcMode.id,zl)*1000);
        }else{
            delayTime[0] =(int)(Double.parseDouble(lcMode.jTime)/Double.parseDouble(lcMode.jValue)*zl*1000);
        }
        if (delayTime[0]<=0){
            ToastUtils.error("Simulation Fail,the open motor time must greater than 0");
            return;
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
//                    ExecuteTheRecipe.WritePLC("配料完成", false, null);
//                    ExecuteTheRecipe.WritePLC("手自切换", true, null);
                    ExecuteTheRecipe.isAutoMode=false;


                    if (lcMode.name.equals("外置仓")){
                        PLCControl.get().openMotorAndReverse(lcMode.num, delayTime[0],ftime, new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                ToastUtils.success("Start Simulation Success......");
                            }
                            @Override
                            public void onFailure(String ErrorMsg) {
                                ToastUtils.error("Start Simulation Failure："+ ErrorMsg);
                            }
                        });
                    }else{
                    PLCControl.get().openMotorAndClose(lcMode.num, delayTime[0], new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            ToastUtils.success("Start Simulation Success......");
                        }
                        @Override
                        public void onFailure(String ErrorMsg) {
                            ToastUtils.error("Start Simulation Failure："+ ErrorMsg);
                        }
                    });
                    }

                } catch (Exception e) {
                    ToastUtils.error("Simulation Open："+ e.getMessage());
                }
            }
        }).start();
        ToastUtils.info("Start Simulation......");
    }
    //endregion

    //region 酱料校准
    /**酱料校准--校准成功自动保存*/
    private void JLJZ(){

        //region 校验及转换数据
        String highLimit=txt_jljz_highLimit.getText().toString().trim();
        String lowLimit=txt_jljz_lowLimit.getText().toString().trim();
        String text_adjFreq=txt_jljz_adjFreq.getText().toString().trim();

        if (lowLimit.isEmpty() || lowLimit.equals("")){
            ToastUtils.warning("校准范围下限不能为空！");
            return;
        }
        if (highLimit.isEmpty() || highLimit.equals("")){
            ToastUtils.warning("校准范围上限不能为空！");
            return;
        }
        if (text_adjFreq.isEmpty() || text_adjFreq.equals("")){
            ToastUtils.warning("校准频率不能为空！");
            return;
        }


        final double weightLowLimit;
        final double weightHighLimit;
        final int adjFreq;
        final double ftime;

        try {
            weightLowLimit=Double.parseDouble(lowLimit);
        }catch (Exception e){
            ToastUtils.error("校准下限异常！" + e.getMessage());
            return;
        }
        try {
            weightHighLimit=Double.parseDouble(highLimit);
        }catch (Exception e){
            ToastUtils.error("校准上限异常！" + e.getMessage());
            return;
        }
        try {
            adjFreq=Integer.parseInt(text_adjFreq);
        }catch (Exception e){
            ToastUtils.error("校准频率异常！" + e.getMessage());
            return;
        }
        try{
            double result=-1.0;
            if (lcMode.fTime!=null){
                result=Double.parseDouble(lcMode.fTime);
                ftime=result>=0?result:0.0;
            }else{
                ftime=0.0;
            }

        }catch (Exception e){
            ToastUtils.error("料仓的反转时间异常，校准时不反转！" + e.getMessage());
            return;
        }
        if (weightLowLimit<0 || (weightLowLimit>=weightHighLimit)){
            ToastUtils.error("校准范围值异常，下限应大于0，且小于上限值！");
            return;
        }
        //endregion

        btn_jljz_startAdj.setEnabled(false);
        btn_jljz_startAdj.setText("正在校准...");
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ExecuteTheRecipe.isAutoMode=false;
                    final double[] currentWeight=new double[]{0};
                    currentWeight[0]=ExecuteTheRecipe.OutletWeigh/10;
                    //出料时间及出料重量对比表。
                    //HashMap<Double,Double> outMaterialMap=new HashMap<Double, Double>();

                    WeightedObservedPoints points=new WeightedObservedPoints();

                    ToastUtils.info("开始酱料校准，时间较长，请耐心等待。");

                    //总共出料时间 和 开始时间。。
                    final long[] time = {0,0};
                    while (currentWeight[0]<=weightHighLimit){
                        //region 错误代码
//                        PLCControl.get().openMotorAndClose(lcMode.num, adjFreq * 1000, new IWriteCallBack() {
//                            @Override
//                            public void onSuccess() {
//                                currentWeight[0]=ExecuteTheRecipe.OutletWeigh/10;
//                                if (currentWeight[0]>=weightLowLimit){
//                                    //出料时间
//                                    long outTime=System.currentTimeMillis()-startTime;
//                                    double time=((double)outTime)/1000;
//                                    outMaterialMap.put(time,currentWeight[0]);
//                                }
//                            }
//                            @Override
//                            public void onFailure(String ErrorMsg) {
//                                //ToastUtils.error("酱料校准开关电机错误，校准失败");
//                            }
//                        });
//                        PLCControl.get().openMotor(lcMode.num, new IWriteCallBack() {
//                            @Override
//                            public void onSuccess() {
//                                try {
//                                    Thread.sleep(adjFreq*1000);
//                                    PLCControl.get().closeMotor(lcMode.num, new IWriteCallBack() {
//                                        @Override
//                                        public void onSuccess() {
//                                            currentWeight[0]=ExecuteTheRecipe.OutletWeigh/10.0;
//                                            if (currentWeight[0]>=weightLowLimit){
//                                                //出料时间
//                                                long outTime=System.currentTimeMillis()-startTime;
//                                                double time=((double)outTime)/1000;
//                                                //outMaterialMap.put(time,currentWeight[0]);
//                                                //方程式里，x是重量，Y才是时间
//                                                points.add(currentWeight[0],time);
//                                            }
//                                        }
//                                        @Override
//                                        public void onFailure(String ErrorMsg) {
//
//                                        }
//                                    });
//                                } catch (Exception e) {
//                                    ToastUtils.error("酱料校准错误 ："+e.getMessage());
//                                }
//                            }
//                            @Override
//                            public void onFailure(String ErrorMsg) {
//
//                            }
//                        });
//endregion


                        PLCControl.get().openMotor(lcMode.num, new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                try {
                                    time[1] = System.currentTimeMillis();
                                    Thread.sleep(adjFreq * 1000);
                                    PLCControl.get().closeMotor(lcMode.num, new IWriteCallBack() {
                                        @Override
                                        public void onSuccess() {
                                            currentWeight[0] = ExecuteTheRecipe.OutletWeigh / 10.0;
                                            if (currentWeight[0] >= weightLowLimit) {
                                                //出料时间
                                                long outTime = System.currentTimeMillis() - time[1];
                                                time[0] += outTime;
                                                double allOutTime = ((double) time[0]) / 1000;
                                                //方程式里，x是重量，Y才是时间
                                                points.add(currentWeight[0], allOutTime);
                                                try {
                                                    if (lcMode.num <= 8) {
                                                        PLCControl.get().reverMotorAndClose(lcMode.num, (int) (ftime * 1000), null);
                                                        Thread.sleep((int)(ftime*1000));
                                                    }
                                                }catch (Exception e){
                                                    ToastUtils.error("酱料校准错误 ："+e.getMessage());
                                                }
                                            }
                                        }
                                        @Override
                                        public void onFailure(String ErrorMsg) {

                                        }
                                    });
                                } catch (Exception e) {
                                    ToastUtils.error("酱料校准错误 ："+e.getMessage());
                                }
                            }
                            @Override
                            public void onFailure(String ErrorMsg) {

                            }
                        });

                    }
                    activity.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            new QMUIDialog.MessageDialogBuilder(activity).setTitle("确定要保存该酱料校准结果吗？")
                                    .setCanceledOnTouchOutside(false)
                                    .addAction("确认", new QMUIDialogAction.ActionListener() {
                                        @Override
                                        public void onClick(QMUIDialog dialog, int index) {
                                            //Toast.makeText(activity.getApplicationContext(), "确认", Toast.LENGTH_SHORT).show();

                                            //region 生成公式
                                            //公式多项式阶数
                                            int degree=3;

                                            // 创建 PolynomialCurveFitter 对象，并进行多项式回归拟合
                                            PolynomialCurveFitter fitter = PolynomialCurveFitter.create(degree);
                                            double[] coefficients = fitter.fit(points.toList());

                                            // 打印回归方程的系数
//                                            for (int i = 0; i < coefficients.length; i++) {
//                                                System.out.print(coefficients[i] + " ");
//                                            }
                                            //endregion

                                            dialog.dismiss();
                                            //lcMode.bcsfValue=result;
                                            QueryDB.UpdateSilosBcsfValue(lcMode.id,String.valueOf(weightLowLimit),String.valueOf(weightHighLimit),String.valueOf(adjFreq));
                                            //QueryDB.UpdateSilosBcsfValue(lcMode.id, result);
                                            QueryDB.UpdateSilosBcsfValue(lcMode.id, Arrays.toString(coefficients));
                                            //QueryDB.UpdateSilosJZTime(lcMode.id,"0",text_ftime);
                                            //ToastUtils.success("酱料校准结果保存成功！");
                                            MessageLog.ShowUserMessage(UserLogEnum.角色操作日志,lcMode.num+"仓位酱料校准结果保存成功。");
                                        }
                                    }).addAction("取消", new QMUIDialogAction.ActionListener() {
                                        @Override
                                        public void onClick(QMUIDialog dialog, int index) {
                                            //Toast.makeText(activity.getApplicationContext(), "取消", Toast.LENGTH_SHORT).show();
                                            dialog.dismiss();
                                        }
                                    }).create(AlertDialogUtils.mCurrentDialogStyle).show();
                        }
                    });
                    //ToastUtils.success("酱料校准结束，数据已保存。");
                }catch (Exception ex){
                    ToastUtils.error("酱料校准失败："+ex.getMessage());
                }finally {
                    activity.runOnUiThread(()->{
                        btn_jljz_startAdj.setEnabled(true);
                        btn_jljz_startAdj.setText("开始校准");
                    });
                }
            }
        }).start();
        ToastUtils.info("开始校准......");
    }
    //endregion

    //region 保存酱料的反转时间
    private void saveJLFTime(){
        String text_ftime=text_jljz_ftime.getText().toString().trim();
        if (text_ftime.isEmpty()||text_ftime.equals("")){
            ToastUtils.warning("反转时间不能为空！");
            return;
        }
        final double ftime;
        try {
            ftime=Double.parseDouble(text_ftime);
        }catch (Exception e){
            ToastUtils.error("反转时间异常！" + e.getMessage());
            return;
        }
        if (ftime<0.0){
            ToastUtils.error("反转时间异常，数值应大于0！" );
            return;
        }
        QueryDB.UpdateSilosJZTime(lcMode.id,"0",String.valueOf(ftime));
        ToastUtils.success("仓位【"+lcMode.num+"】反转时间保存成功！" );
    }
    //endregion
    //region 保存物料校准参数
    public void SaveWLJZ() {
        String stime = wljz1.getText().toString();
        String ftime = wljz2.getText().toString();
        String zl = wljz3.getText().toString();

        if (stime.equals("")) {
            ToastUtils.warning("校准基准时间不能为空！");
            return;
        }

        if (zl.equals("")) {
            ToastUtils.warning("校准重量不能为空！");
            return;
        }

        int stime_1 = 0;
        int ftime_1 = 0;

        try {
            stime_1 = (int) Math.round((Double.parseDouble(stime) * 10));
        } catch (Exception e) {
            ToastUtils.error("时间异常！" + e.getMessage());
            return;
        }

        try {
            Double.parseDouble(zl);
        } catch (Exception e) {
            ToastUtils.error("重量异常！" + e.getMessage());
            return;
        }
        if (!ConfigName.getInstance().versionSelectionEnum.equals("奶茶机")) {
            if (ftime.equals("")) {
                ToastUtils.warning("反转基准时间不能为空！");
                return;
            }
            try {
                ftime_1 = (int) Math.round((Double.parseDouble(ftime) * 10));
            } catch (Exception e) {
                ToastUtils.error("时间异常！" + e.getMessage());
                return;
            }
//            ExecuteTheRecipe.WritePLC("反转时间", (short) ftime_1, new IWriteCallBack() {
//                @Override
//                public void onSuccess() {
//                    ToastUtils.info("反转时间保存成功！");
//                }
//
//                @Override
//                public void onFailure(String ErrorMsg) {
//                    ToastUtils.error("反转时间保存失败！");
//                }
//            });
        }
        lcMode.fTime=ftime;
        lcMode.jTime=stime;
        lcMode.jValue=zl;

        ArrayList<BPA_SILOS> Ss=QueryDB.GetSilosALL();
        for (BPA_SILOS item:Ss)
        {
            QueryDB.UpdateSilosJZTime(item.id, stime, ftime);
        }
        QueryDB.UpdateJYZ(lcMode.id, zl);
        ToastUtils.success("物料校准时间保存成功！");

//        ExecuteTheRecipe.WritePLC("基准时间", (short) stime_1, new IWriteCallBack() {
//            @Override
//            public void onSuccess() {
//                ToastUtils.info("校准基准时间保存成功！");
//            }
//
//            @Override
//            public void onFailure(String ErrorMsg) {
//                ToastUtils.error("校准基准时间保存失败！");
//            }
//        });
    }
    //endregion

    //region 物料校准
    public void WLJZ() {

        //region 物料校准
        String stime = wljz1.getText().toString();
        String ftime = wljz2.getText().toString();

        if (stime.equals("")) {
            ToastUtils.warning("校准基准时间不能为空！");
            return;
        }
        final int[] stime_1 = {0};

        try {
            stime_1[0] = (int) Math.round((Double.parseDouble(stime)));
        } catch (Exception e) {
            ToastUtils.error("时间异常！" + e.getMessage());
            return;
        }
        //endregion

        new Thread(new Runnable() {
            @Override
            public void run() {
                try {

                    ExecuteTheRecipe.isAutoMode=false;
                    PLCControl.get().openMotor(lcMode.num, new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            new Handler(Looper.getMainLooper()).postDelayed(()->{
                                PLCControl.get().closeMotor(lcMode.num, new IWriteCallBack() {
                                    @Override
                                    public void onSuccess() {
                                        ToastUtils.info("通道校准完成--请确认重量！");
                                    }
                                    @Override
                                    public void onFailure(String ErrorMsg) {
                                        ToastUtils.error("通道校准---关闭通道失败！");
                                    }
                                });
                            },stime_1[0]*1000);
                        }

                        @Override
                        public void onFailure(String ErrorMsg) {
                            ToastUtils.error("通道校准---开启通道失败！");
                        }
                    });
                } catch (Exception e) {
                }
            }
        }).start();
    }
    //endregion

    //region 补偿校准
    public void SaveBCJZ() {
        Short H = 0;
        Short L = 0;
        Short time = 0;
        try {
            H = Short.parseShort(bcjz_gxs.getText().toString());
            L = Short.parseShort(bcjz_dxs.getText().toString());
            int ftime = (int) Math.round((Double.parseDouble(bcjz_clsj.getText().toString()) * 10));
            time = (short) ftime;
        } catch (Exception ex) {
            ToastUtils.error("数据不合法,保存变量失败!" + ex.getMessage());
            return;
        }
        Short finalH = H;
        Short finalL = L;
        Short finalTime = time;

        lcMode.Gxs = bcjz_gxs.getText().toString();
        lcMode.Lxs = bcjz_dxs.getText().toString();
        lcMode.tdclsj = bcjz_clsj.getText().toString();

        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ExecuteTheRecipe.WritePLC("高系数" + lcMode.num, finalH, null);
                    ExecuteTheRecipe.WritePLC("低系数" + lcMode.num, finalL, null);
                    ExecuteTheRecipe.WritePLC("补偿" + lcMode.num + "时间", finalTime, new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            ToastUtils.info("保存变量成功!");
                            QueryDB.UpdateSilosisOpenbcsf(lcMode.id, bcjz_gxs.getText().toString(),
                                    bcjz_dxs.getText().toString(), bcjz_clsj.getText().toString());
                        }

                        @Override
                        public void onFailure(String ErrorMsg) {
                            ToastUtils.warning("保存变量失败!");
                        }
                    });
                } catch (Exception e) {

                }
            }
        }).start();

    }
    //endregion

    //region 定时器

    /**
     * 启动定时器
     */
    public void StartTime() {
        isStartMg=true;
        runtime.setBase(SystemClock.elapsedRealtime());
        runtime.start();
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    //自动模式
                    ExecuteTheRecipe.WritePLC("手自切换", false, null);
                    //开启
                    ExecuteTheRecipe.WritePLC("手动控制" + lcMode.num, true, null);
                } catch (Exception e) {

                }
            }
        }).start();
    }

    /**
     * 停止定时器
     */
    public int StopTime() {
        long elapsedMillis = SystemClock.elapsedRealtime() - runtime.getBase();
        runtime.stop();
        isStartMg=false;
        int time = (int) (elapsedMillis / 1000);
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ExecuteTheRecipe.WritePLC("手动控制" + lcMode.num, false, null);
                } catch (Exception e) {

                }
            }
        }).start();
        return time;//当前点击多少秒
    }
    //endregion


    //region 数据校验
    /**物料校准参数校验*/
    private void validateForWLJZ(){

    }
    //endregion


    /**键值都为Double的HashMap转换为字符串，提供给酱料校准使用。*/
    private String jzDataToString(Map<Double,Double> hashMap){
        String result="";
        if (hashMap.isEmpty()){
            result= "";
        }
        StringBuilder stringBuilder=new StringBuilder();
        for (Map.Entry<Double,Double> entry:hashMap.entrySet()){
            stringBuilder.append(entry.getKey()).append(",").append(entry.getValue()).append("|");
        }
        if (stringBuilder.length()>0){
            stringBuilder.setLength(stringBuilder.length()-1);
            result=stringBuilder.toString();
        }
        return result;
    }

}
